cpu 386
org	0100h

;Setup video mode.
mov	al, 13h
int	10h

;get 8x16 font
mov ax, 1130h
mov bh, 0x06
int 10h

push 0xa000
pop fs

foreverloop:

pixelloop:

mov ax, di
mov cx, 320
xor dx, dx
div cx

;Skip the first 8 rows
sub al, 8
jb drawbackground
mov cl, 64
div cl

;ah is character line
;al is text rows

mov cx, 0
counter:
cmp cx, 1024*3
jae dontshift

shifttext:

mov bx, cx
shr bx, 10
add bl, '0'
mov [textEvoke+7], bl

and cx, 4*256-1
cmp ch, al

jb drawbackground
ja dontshift
sub dx, 512
mov ch, 0
shl cx, 1
add dx, cx

dontshift:

;center stuff
sub dx, 32
jb drawbackground
or dh, dh
jnz drawbackground


;jmp drawpixel
movzx bx, al
shl bx, 3

mov si, dx
shr si, 5
and dx, 31

;Get character
movzx si, byte [textEvoke+bx+si]

;get the font
movzx ax, ah
shr ax, 2
shr dx, 2

mov cx, dx
shl si, 4
add si, ax

shl byte [es:bp+si],cl
jnc drawbackground

mov al, 15
jmp drawpixel

drawbackground:
mov ax, [counter-2]
cmp ax, 1024*3+256+256
ja  drawpixel

drawzero:
mov al, 0

drawpixel:
mov [fs:di], al
inc di
jnz pixelloop

;Wait for retrace
mov	dx,0x3da
wait_off:
in	al,dx
test al,8

jnz	wait_off
wait_on:
in al,dx
test al,8
jz wait_on

; stop after 3 frames
mov ax, [counter-2]
inc ax
;inc ax
mov [counter-2], ax
cmp ax, 1024*2
ja allfine

and ah, 3
cmp ah, 3
je sadtimes

;disable speaker
mov     al, 0000000
out     61h, al
jmp foreverloop

sadtimes:
push 0
jmp beep

allfine:

sub ax, 1024*3+256
jb foreverloop

push ax

mov si, textCounter+7
mov cl, 10

decimals:
xor dx, dx
div cx

add dl, '0'
mov [si], dl

dec si
or ax, ax
jnz decimals

beep:
;Enable the speaker
mov     al, 00000011b  
out     61h, al

mov     al, 0xa6		;timer 2, mode 3, hi byte only
out     43h, al         ; a new countdown value

pop ax

neg 	al
out 	42h, al

jmp foreverloop

textEvoke:
db 'EVOKE 20'

textVisitors:
db 'VISITORS'

textCounter:
db '       0'

